require "class" -- Class System
HC = require "HardonCollider"
require "game" -- Level Screen
require "entities.player" -- Player Entity
require "entities.block" -- Blocks


function love.load()
	collider = HC(100, gamecollide)
	--[[
		2013 Haibutsu Kinzoku (Scrap Metal 2013)
		(Working title, will need to be changed if the game turns non-freeware)
		
		
		Created by: ???
		Genre: 2D Platformer
		Version: 0.0.0.0101 (Major.Minor.Revision.Build)
		
		
		Developer's Quickguide:
			LevelScreen: Consult game.lua
			MainLoop: Consult this file
			Ponies: Consult this gun
			Player: Consult player.lua
			
			
		Index of States:
			0: ?
			1: ?
			2: LevelScreen
	--]]
	
	--************************************************
	build_number = 0101 -- Current Build Number, Indexed by Month/Day, example: 1101 (November 1st, and that date was chosen at random.)
	debug_mode = true -- adds specific features not available normally
	
	game_state = 0
	current_level = 0
	love.graphics.setMode(256*3,224*3)
	--************************************************
	sprites = {
		love.graphics.newImage("graphics/TestZone.png"), -- TestZone
		love.graphics.newImage("graphics/Kinzo.png"), -- Kinzo
	}
	--************************************************
	
	
	
	--This'll hold all of the quads in the game.
	--************************************************
	quads = {
		-- quads for the test zone tileset
		love.graphics.newQuad(0,0,16,16,64,64),
		love.graphics.newQuad(16,0,16,16,64,64),
		love.graphics.newQuad(32,0,16,16,64,64),
		love.graphics.newQuad(48,0,16,16,64,64),
		love.graphics.newQuad(0,16,16,16,64,64),
		love.graphics.newQuad(16,16,16,16,64,64),
		love.graphics.newQuad(32,16,16,16,64,64),
		love.graphics.newQuad(48,16,16,16,64,64),
		love.graphics.newQuad(0,32,16,16,64,64),
		love.graphics.newQuad(16,32,16,16,64,64),
		love.graphics.newQuad(32,32,16,16,64,64),
		love.graphics.newQuad(48,32,16,16,64,64),
		love.graphics.newQuad(0,48,16,16,64,64),
		love.graphics.newQuad(16,48,16,16,64,64),
		love.graphics.newQuad(32,48,16,16,64,64),
		love.graphics.newQuad(48,48,16,16,64,64),
		-- all of this mess ^ relates to the test zone tileset's quads
		
		
		-- Everything here belongs to Kinzo's quads
		love.graphics.newQuad(0,0,16,16,96,16),
		love.graphics.newQuad(16,0,16,16,96,16),
		love.graphics.newQuad(32,0,16,16,96,16),
		love.graphics.newQuad(48,0,16,16,96,16),
		love.graphics.newQuad(64,0,16,16,96,16),
		love.graphics.newQuad(80,0,16,16,96,16),
	}
	--************************************************
	--love.graphics.setCaption("HAIBUTSU2013")
	--love.graphics.setMode(256,224)
	game_load()
	--************************************************


end



function love.update(dt)
	-- Make sure everything gets updated accordingly
	--************************************************
	if game_state == 0 then
	
	end
	
	if game_state == 1 then
	
	end 
	
	if game_state == 2 then
		game_update(dt)
	end
	--************************************************
end




function love.draw()
	-- Draw everything up
	--************************************************
	if game_state == 0 then
	
	end
	
	if game_state == 1 then
	
	end 
	
	if game_state == 2 then
		game_draw()
	end
	--************************************************
end

function love.keypressed(key, unix)
	-- keep those keys in line sir
	--************************************************
	if game_state == 0 then
	
	end
	
	if game_state == 1 then
	
	end 
	
	if game_state == 2 then
		game_keypressed(key, unix)
	end
	--************************************************
	
	
	-- autoquit key (might remove this as i see fit)
	--************************************************
	if key == "f8" then
		love.event.push("quit")
	end
	--************************************************
end

function love.keyreleased(key, unix)
	--************************************************
	if game_state == 0 then
	
	end
	
	if game_state == 1 then
	
	end 
	
	if game_state == 2 then
		game_keyreleased(key, unix)
	end
	--************************************************
end

--************************************************
--EXTRA FUNCTIONS AND OTHER CRAP
--(WE CARE)

--************************************************
function load_map()
	local x = love.filesystem.load("maps/level_"..current_level..".nkz"); x(); -- i made this simple
end

--************************************************

function CheckCollision(ax1,ay1,aw,ah, bx1,by1,bw,bh)
  local ax2,ay2,bx2,by2 = ax1 + aw, ay1 + ah, bx1 + bw, by1 + bh
  return ax1 < bx2 and ax2 > bx1 and ay1 < by2 and ay2 > by1
end
--************************************************
