--[[

	EXPLAINING CRAP 101: BLOCKS
	
	Blocks are mere entities, you're right.
	However, they are collidable, and have different types.
	
	These types, for example, could make a block solid, dangerous, or something along the lines of that.
	
	Aren't I clever? (no)


--]]

block = class:new()

function block:init(x,y,tile_index,tile_number)
	self.x = x
	self.y = y
	self.w = 16
	self.h = 16
	self.t_index = tile_index
	self.t_num = tile_number

	-- Hardon Collider init
	self.rect = collider:addRectangle(self.x, self.y, self.w, self.h)
	collider:addToGroup("tiles", self.rect)
	collider:setPassive(self.rect)
end



function block:draw()
	love.graphics.drawq(sprites[self.t_index],quads[self.t_num],self.x,self.y) -- no reason to make it more involved
end
